/*
 * Copyright 2009-2010 the Fess Project and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

package jp.sf.fess.db.cbean.cq.ciq;

import jp.sf.fess.db.cbean.DataCrawlingConfigCB;
import jp.sf.fess.db.cbean.cq.DataConfigToBrowserTypeMappingCQ;
import jp.sf.fess.db.cbean.cq.DataConfigToLabelTypeMappingCQ;
import jp.sf.fess.db.cbean.cq.DataConfigToRoleTypeMappingCQ;
import jp.sf.fess.db.cbean.cq.DataCrawlingConfigCQ;
import jp.sf.fess.db.cbean.cq.bs.AbstractBsDataCrawlingConfigCQ;
import jp.sf.fess.db.cbean.cq.bs.BsDataCrawlingConfigCQ;

import org.seasar.dbflute.cbean.ConditionQuery;
import org.seasar.dbflute.cbean.ckey.ConditionKey;
import org.seasar.dbflute.cbean.coption.ConditionOption;
import org.seasar.dbflute.cbean.cvalue.ConditionValue;
import org.seasar.dbflute.cbean.sqlclause.SqlClause;

/**
 * The condition-inline-query of DATA_CRAWLING_CONFIG.
 * @author DBFlute(AutoGenerator)
 */
public class DataCrawlingConfigCIQ extends AbstractBsDataCrawlingConfigCQ {

    // ===================================================================================
    //                                                                           Attribute
    //                                                                           =========
    protected BsDataCrawlingConfigCQ _myCQ;

    // ===================================================================================
    //                                                                         Constructor
    //                                                                         ===========
    public DataCrawlingConfigCIQ(ConditionQuery childQuery,
            SqlClause sqlClause, String aliasName, int nestLevel,
            BsDataCrawlingConfigCQ myCQ) {
        super(childQuery, sqlClause, aliasName, nestLevel);
        _myCQ = myCQ;
        _foreignPropertyName = _myCQ.getForeignPropertyName();// Accept foreign property name.
        _relationPath = _myCQ.getRelationPath();// Accept relation path.
    }

    // ===================================================================================
    //                                                             Override about Register
    //                                                             =======================
    @Override
    protected void reflectRelationOnUnionQuery(ConditionQuery baseQueryAsSuper,
            ConditionQuery unionQueryAsSuper) {
        throw new UnsupportedOperationException(
                "InlineQuery must not need UNION method: " + baseQueryAsSuper
                        + " : " + unionQueryAsSuper);
    }

    @Override
    protected void setupConditionValueAndRegisterWhereClause(ConditionKey k,
            Object v, ConditionValue cv, String col) {
        regIQ(k, v, cv, col);
    }

    @Override
    protected void setupConditionValueAndRegisterWhereClause(ConditionKey k,
            Object v, ConditionValue cv, String col, ConditionOption op) {
        regIQ(k, v, cv, col, op);
    }

    @Override
    protected void registerWhereClause(String whereClause) {
        registerInlineWhereClause(whereClause);
    }

    @Override
    protected String getInScopeSubQueryRealColumnName(String columnName) {
        if (_onClauseInline) {
            throw new UnsupportedOperationException(
                    "InScopeSubQuery of on-clause is unsupported");
        }
        return _onClauseInline ? getRealAliasName() + "." + columnName
                : columnName;
    }

    @Override
    protected void registerExistsSubQuery(ConditionQuery subQuery,
            String columnName, String relatedColumnName, String propertyName) {
        throw new UnsupportedOperationException(
                "Sorry! ExistsSubQuery at inline view is unsupported. So please use InScopeSubQyery.");
    }

    // ===================================================================================
    //                                                                Override about Query
    //                                                                ====================
    protected ConditionValue getCValueId() {
        return _myCQ.getId();
    }

    public String keepId_InScopeSubQuery_DataConfigToBrowserTypeMappingList(
            DataConfigToBrowserTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_InScopeSubQuery_DataConfigToBrowserTypeMappingList(subQuery);
    }

    public String keepId_InScopeSubQuery_DataConfigToLabelTypeMappingList(
            DataConfigToLabelTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_InScopeSubQuery_DataConfigToLabelTypeMappingList(subQuery);
    }

    public String keepId_InScopeSubQuery_DataConfigToRoleTypeMappingList(
            DataConfigToRoleTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_InScopeSubQuery_DataConfigToRoleTypeMappingList(subQuery);
    }

    public String keepId_NotInScopeSubQuery_DataConfigToBrowserTypeMappingList(
            DataConfigToBrowserTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_NotInScopeSubQuery_DataConfigToBrowserTypeMappingList(subQuery);
    }

    public String keepId_NotInScopeSubQuery_DataConfigToLabelTypeMappingList(
            DataConfigToLabelTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_NotInScopeSubQuery_DataConfigToLabelTypeMappingList(subQuery);
    }

    public String keepId_NotInScopeSubQuery_DataConfigToRoleTypeMappingList(
            DataConfigToRoleTypeMappingCQ subQuery) {
        return _myCQ
                .keepId_NotInScopeSubQuery_DataConfigToRoleTypeMappingList(subQuery);
    }

    public String keepId_ExistsSubQuery_DataConfigToBrowserTypeMappingList(
            DataConfigToBrowserTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "ExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_ExistsSubQuery_DataConfigToLabelTypeMappingList(
            DataConfigToLabelTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "ExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_ExistsSubQuery_DataConfigToRoleTypeMappingList(
            DataConfigToRoleTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "ExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_NotExistsSubQuery_DataConfigToBrowserTypeMappingList(
            DataConfigToBrowserTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "NotExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_NotExistsSubQuery_DataConfigToLabelTypeMappingList(
            DataConfigToLabelTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "NotExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_NotExistsSubQuery_DataConfigToRoleTypeMappingList(
            DataConfigToRoleTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "NotExistsSubQuery at inline() is unsupported! Sorry!");
    }

    public String keepId_SpecifyDerivedReferrer_DataConfigToBrowserTypeMappingList(
            DataConfigToBrowserTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Specify)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_SpecifyDerivedReferrer_DataConfigToLabelTypeMappingList(
            DataConfigToLabelTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Specify)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_SpecifyDerivedReferrer_DataConfigToRoleTypeMappingList(
            DataConfigToRoleTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Specify)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_DataConfigToBrowserTypeMappingList(
            DataConfigToBrowserTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_DataConfigToBrowserTypeMappingListParameter(
            Object parameterValue) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_DataConfigToLabelTypeMappingList(
            DataConfigToLabelTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_DataConfigToLabelTypeMappingListParameter(
            Object parameterValue) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_DataConfigToRoleTypeMappingList(
            DataConfigToRoleTypeMappingCQ subQuery) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    public String keepId_QueryDerivedReferrer_DataConfigToRoleTypeMappingListParameter(
            Object parameterValue) {
        throw new UnsupportedOperationException(
                "(Query)DerivedReferrer at inline() is unsupported! Sorry!");
    }

    protected ConditionValue getCValueName() {
        return _myCQ.getName();
    }

    protected ConditionValue getCValueHandlerName() {
        return _myCQ.getHandlerName();
    }

    protected ConditionValue getCValueHandlerParameter() {
        return _myCQ.getHandlerParameter();
    }

    protected ConditionValue getCValueHandlerScript() {
        return _myCQ.getHandlerScript();
    }

    protected ConditionValue getCValueBoost() {
        return _myCQ.getBoost();
    }

    protected ConditionValue getCValueAvailable() {
        return _myCQ.getAvailable();
    }

    protected ConditionValue getCValueSortOrder() {
        return _myCQ.getSortOrder();
    }

    protected ConditionValue getCValueCreatedBy() {
        return _myCQ.getCreatedBy();
    }

    protected ConditionValue getCValueCreatedTime() {
        return _myCQ.getCreatedTime();
    }

    protected ConditionValue getCValueUpdatedBy() {
        return _myCQ.getUpdatedBy();
    }

    protected ConditionValue getCValueUpdatedTime() {
        return _myCQ.getUpdatedTime();
    }

    protected ConditionValue getCValueDeletedBy() {
        return _myCQ.getDeletedBy();
    }

    protected ConditionValue getCValueDeletedTime() {
        return _myCQ.getDeletedTime();
    }

    protected ConditionValue getCValueVersionNo() {
        return _myCQ.getVersionNo();
    }

    // ===================================================================================
    //                                                                     Scalar SubQuery
    //                                                                     ===============
    public String keepScalarSubQuery(DataCrawlingConfigCQ subQuery) {
        throw new UnsupportedOperationException(
                "ScalarSubQuery at inline() is unsupported! Sorry!");
    }

    // ===================================================================================
    //                                                             MySelf InScope SubQuery
    //                                                             =======================
    public String keepMyselfInScopeSubQuery(DataCrawlingConfigCQ subQuery) {
        throw new UnsupportedOperationException(
                "MyselfInScopeSubQuery at inline() is unsupported! Sorry!");
    }

    // ===================================================================================
    //                                                                       Very Internal
    //                                                                       =============
    // Very Internal (for Suppressing Warn about 'Not Use Import')
    String xiCB() {
        return DataCrawlingConfigCB.class.getName();
    }

    String xiCQ() {
        return DataCrawlingConfigCQ.class.getName();
    }
}
